;rom2pwm by utz 11'2013
;a beeper noise/glitch synthesizer in 64 bytes

	org #8000
	
begin
	exx			;initialize hl as set by BASIC
	ld d,h
	ld e,#70

init	ld bc,64510		; keyboard row Q..T
	in a,(c)		; see what keys are pressed.
	rra
	jr nc,sup
	rra
	jr nc,sdown
	rra
	jr nc,tup
	rra
	jr nc,tdown
	rra
	jr nc,begin
	
elp	push hl

	sbc hl,de
	pop hl
	jr nc,begin
ok	push hl
	push de

rdata	push hl
	sbc hl,de
	jr nc,pdone
	pop hl
	ld b,(hl)
	
waitlp	out (#fe),a
	djnz waitlp
	
	inc hl
	xor #13			;flip bit 4 and get some color to the border
	jr rdata

pdone	pop hl
	pop de
	pop hl
	jr init

sup	inc hl
	jr elp

sdown	dec hl
	jr elp

tup	inc de
	jr elp

tdown	dec de
	jr elp

end